---
product: "AG Charts"
title: "Tooltips"
description: "JavaScript Chart Tooltips provide extra contextual information to JavaScript charts. Customise tooltips and control their position, range, arrow and interactivity."
framework: javascript
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-highlighting/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Tooltips

Tooltips allow users to see extra contextual information without overcrowding the chart.

> **Note**
>
> This page covers Series tooltips. For tooltips on other chart elements, see the API options for [title](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-title-tooltip), [subtitle](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-subtitle-tooltip), [footnote](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-footnote-tooltip), and [legend items](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-legend-item-tooltip).

## Default Tooltip

The tooltip content is based on the data values and keys of the series. If provided, the `_Name` properties will be used instead of the `_Key` properties.

#### Default Tooltip

```ts
import {
  AgBarSeriesOptions,
  AgCartesianChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "month",
      stacked: true,
      yKey: "value1",
      yName: "Sweaters Made",
    },
    {
      type: "bar",
      xKey: "month",
      stacked: true,
      yKey: "hats_made",
      yName: "Hats Made",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function yNamesChange(event: Event) {
  const yNames = [
    "Sweaters Made",
    "Hats Made",
    "Gloves Made",
    "Socks Made",
    "Sunglasses Made",
  ];
  const add = (event.target as HTMLInputElement).value === "add";
  options.series?.forEach((series, index) => {
    (series as AgBarSeriesOptions).yName = add ? yNames[index] : undefined;
  });

  chart.update(options);
}

function showNumSeries(event: Event) {
  const num = Number((event.target as HTMLInputElement).value);
  const hasYNames = (options.series![0] as AgBarSeriesOptions).yName != null;
  if (num === 1) {
    options.series = [
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "value1",
        yName: "Sweaters Made",
      },
    ];
  } else if (num === 2) {
    options.series = [
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "value1",
        yName: "Sweaters Made",
      },
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "hats_made",
        yName: "Hats Made",
      },
    ];
  } else {
    options.series = [
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "value1",
        yName: "Sweaters Made",
      },
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "hats_made",
        yName: "Hats Made",
      },
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "gloves_made",
        yName: "Gloves Made",
      },
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "socks_made",
        yName: "Socks Made",
      },
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "sunglasses_made",
        yName: "Sunglasses Made",
      },
    ];
  }
  if (!hasYNames) {
    for (const series of options.series ?? []) {
      (series as AgBarSeriesOptions).yName = undefined;
    }
  }

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).yNamesChange = yNamesChange;
  (<any>window).showNumSeries = showNumSeries;
}
```

[Live example: Default Tooltip](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/default-tooltip/)

```js
{
    series: [
        { type: 'bar', xKey: 'month', stacked: true, yKey: 'value1', yName: 'Sweaters Made' },
        { type: 'bar', xKey: 'month', stacked: true, yKey: 'hats_made', yName: 'Hats Made' },
    ],
}
```

In this example:

- The `yName` is used in the tooltip and legend when provided.
- The default [tooltip mode](https://www.ag-grid.com/charts/archive/14.2.0/javascript/tooltips/#tooltip-modes) is:
  - `compact` when showing a single series with no `yName`.
  - `single` when showing more than 3 series, or a single series with `yName`.
  - `shared` when showing 3 or fewer series.

The `_Name` keys mirror the data keys and differ between series types. See the series specific [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-series) for more details.

## Tooltip Modes

By default a shared tooltip will be used for most cartesian charts containing 3 or fewer series. Use the mode option to show a `single`, `shared` or `compact` tooltip.

#### Tooltip Mode

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AgTooltipMode,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  tooltip: {
    mode: "single",
  },
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "Onshore wind",
      yName: "Onshore Wind",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "Offshore wind",
      yName: "Offshore Wind",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "Solar photovoltaics",
      yName: "Solar Photovoltaics",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "Plant biomass",
      yName: "Plant Biomass",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "Landfill gas",
      yName: "Landfill Gas",
    },
  ],
  axes: {
    x: {
      type: "unit-time",
    },
    y: {
      position: "right",
      type: "number",
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setTooltipMode(event: Event) {
  options.tooltip!.mode = (event.target as HTMLInputElement)
    .value as AgTooltipMode;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setTooltipMode = setTooltipMode;
}
```

[Live example: Tooltip Mode](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/tooltip-mode/)

```js
{
    tooltip: {
        mode: 'shared', // or 'single' or 'compact'
    },
}
```

The options for `mode` are:

- `single` - shows a title, symbol and data values for a single series.
- `shared` - shows a merged tooltip, combining the tooltips of all series sharing the same x-value.
- `compact` - shows fewer data fields and uses less padding.

See [Highlight Modes](https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-highlighting/#highlight-modes) to apply the same shared grouping to series highlighting.

## Tooltip Position

By default the tooltip is anchored to the hovered datapoint. Use `placement`, `anchorTo` and `offset` to customise this.

#### Tooltip Position

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { AgTooltipAnchorTo, AgTooltipPlacement } from "ag-charts-types";
import { getData } from "./data";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "month",
      yKey: "sweaters",
      yName: "Sweaters Made",
    },
  ],
  tooltip: {
    position: {
      placement: "top",
      offset: 12,
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setAnchorTo(anchorTo: AgTooltipAnchorTo) {
  options.tooltip!.position!.anchorTo = anchorTo;

  chart.update(options);
}

function setPlacement(placement: string) {
  options.tooltip!.position!.placement = placement.split(
    /,\s+/g,
  ) as AgTooltipPlacement[];

  chart.update(options);
}

function setOffset(event: Event) {
  const value = Number((event.target as HTMLInputElement).value);
  document.getElementById("offsetValue")!.textContent = String(value);
  options.tooltip!.position!.offset = value;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setAnchorTo = setAnchorTo;
  (<any>window).setPlacement = setPlacement;
  (<any>window).setOffset = setOffset;
}
```

[Live example: Tooltip Position](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/tooltip-position/)

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['top', 'bottom', 'left', 'right'],
            offset: 12,
        },
    },
}
```

### Placement

The `placement` option positions the tooltip relative to its [anchor point](https://www.ag-grid.com/charts/archive/14.2.0/javascript/tooltips/#anchor-point), such as `top` or `top-right`. See the [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/javascript/tooltips/#reference-AgChartTooltipOptions-position-placement) for the full list of values.

Fallback positions can be provided in an array of `placement` values. The tooltip will use the first position that has sufficient space.

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['left', 'right'],
        },
    },
}
```

In the above example:

- Change the 'Placement' dropdown to 'Left + Right fallback'.
- Hover the leftmost datapoint and see that the tooltip goes to the right of the marker as there is no room on the left.

### Anchor Point

The options for `anchorTo` are:

- `node` - the active datapoint, such as the marker or bar.
- `pointer` - the mouse pointer or [single finger touch](https://www.ag-grid.com/charts/archive/14.2.0/javascript/touch/#single-finger-touch-dragging) position.
- `chart` - the chart container.

### Offset

Use `tooltip.position.offset` to control the gap between the tooltip and its anchor point in the placement direction, or `xOffset` and `yOffset` for specific horizontal and vertical offsets.

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['right', 'left'],
            offset: 20,
        },
    },
}
```

In the above example:

- Change the 'Placement' dropdown to 'Left + Right fallback' and change the 'Offset' value.
- Hover the leftmost datapoint and see that the offset is applied to the right of the marker, hover the rightmost datapoint and see that the offset is applied to the left.
- The directional `offset` can be used together with `xOffset` and `yOffset`.

## Tooltip Arrow

The default tooltip displays an arrow below it to indicate its exact point of origin. This is removed when the tooltip is constrained by the container or has an `xOffset` or `yOffset` supplied. The directional `offset` does not suppress the arrow.

#### Removing the Tooltip Arrow

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "month",
      stacked: true,
      yKey: "value1",
      yName: "Sweaters Made",
    },
    {
      type: "bar",
      xKey: "month",
      stacked: true,
      yKey: "hats_made",
      yName: "Hats Made",
    },
  ],
  tooltip: {
    showArrow: true,
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function toggleTooltipArrow() {
  options.tooltip!.showArrow = !options.tooltip!.showArrow;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).toggleTooltipArrow = toggleTooltipArrow;
}
```

[Live example: Removing the Tooltip Arrow](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/default-tooltip-arrow/)

Use the `tooltip.showArrow` option to change this behaviour.

```js
{
    tooltip: {
        showArrow: false,
    },
}
```

## Tooltip Pagination

Pagination allows cycling through overlapping datapoints by hovering and then clicking on the mouse. Use `pagination: true` to enable.

#### Tooltip Pagination

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  BubbleSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";

ModuleRegistry.registerModules([
  BubbleSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions<DataType> = {
  data: getData(),
  title: {
    text: "Most Populous Cities",
  },
  footnote: {
    text: "Source: Simple Maps",
  },
  series: [
    {
      type: "bubble",
      title: "Most populous cities",
      xKey: "lon",
      xName: "Longitude",
      yKey: "lat",
      yName: "Latitude",
      sizeKey: "population",
      sizeName: "Population",
      labelKey: "city",
      labelName: "City",
      maxSize: 50,
      tooltip: {
        renderer: ({ datum }) => ({ title: datum.city }),
      },
    },
  ],
  tooltip: {
    pagination: true,
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Tooltip Pagination](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/tooltip-pagination/)

Pagination will only become available when two or more data points are under the cursor.

```js
{
    tooltip: {
        pagination: true,
    },
}
```

In the above example:

- Hover overlapping bubbles.
- The cursor turns into a hand and the tooltip displays the number of data points under the cursor.
- Click in the current position to cycle through the data points, highlighting and displaying the tooltip for each in turn.

## Customisation

The exact contents and structure of a tooltip depends on the series and keys used.

Tooltips can contain any number of the following items, in order:-

- A heading - typically the x-value for a cartesian series.
- A series symbol - this graphically depicts a series and usually matches the legend item.
- A title - typically the identifying value for non-cartesian series.
- Some data rows - these contain one or more label and value pairs corresponding to information for a series.

### Using CSS Styles

#### Default Tooltip with Custom Styling

```ts
import {
  AgChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgChartOptions = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "month",
      yKey: "sweaters",
      yName: "Sweaters Made",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Default Tooltip with Custom Styling](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/default-tooltip-styling/)

The default tooltip uses the following CSS classes for the tooltip elements:

- `ag-charts-tooltip` for the entire tooltip container.
- `ag-charts-tooltip-heading` and `ag-charts-tooltip-title` for the tooltip headings and titles.
- `ag-charts-tooltip-symbol` for the series symbol.
- `ag-charts-tooltip-label` and `ag-charts-tooltip-value` for the elements in the data rows.

Adding custom CSS to these will change the styling of all the tooltips in your app.

```css
.ag-charts-tooltip {
    background-color: papayawhip;
    border: 2px solid peachpuff;
    color: maroon;
}

.ag-charts-tooltip-heading {
    font-weight: bold;
}
```

Note that your styles don't override the default tooltip styles but complement them.

### Modifying Content

The tooltip's content can be customised within the default template by using a `renderer` callback function.

#### Modifying Tooltip Content

```ts
import {
  AgCartesianSeriesTooltipRendererParams,
  AgChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";

function renderer({
  datum,
  yKey,
  yName,
}: AgCartesianSeriesTooltipRendererParams<DataType>) {
  return {
    heading: "Clothing Production",
    title: yName?.toUpperCase(),
    data: [
      {
        label: datum.month,
        value: Number(datum[yKey]).toFixed(1),
      },
    ],
  };
}
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgChartOptions<DataType> = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "month",
      tooltip: { renderer },
      yKey: "sweaters",
      yName: "Sweaters made",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "month",
      tooltip: { renderer },
      yKey: "hats",
      yName: "Hats made",
      stacked: true,
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Modifying Tooltip Content](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/tooltip-content-title/)

```js
{
    tooltip: {
        renderer: function ({ datum, xKey, yKey, yName }) {
            return {
                heading: 'Clothing Production',
                title: yName.toUpperCase(),
                data: [
                    {
                        label: datum[xKey],
                        value: datum[yKey].toFixed(1),
                    },
                ],
            };
        },
    },
}
```

In this configuration:

- The `renderer` receives values associated with the highlighted data point. The actual type of the `params` object passed into the tooltip renderer will depend on the series type being used.
- The `renderer` returns an object with optional `heading`, `title`, `symbol`, and `data` fields.
- The `heading` and `title` must be plain text.
- The `data` field consists of an array of `label` and `value` fields, which are both plain text.
- Returning an empty string for any field will cause it to be omitted from the rendered tooltip.

### Modifying the Symbol

The tooltip symbol (the coloured marker that represents the series) can be customised using the `symbol` property in the renderer's return object.

Whether the symbol defaults to use a `marker`, `line`, or both depends on the series type and options used. Use the `enabled` option for each element to override this.

#### Customising the Tooltip Symbol

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AllCommunityModule,
  ModuleRegistry,
} from "ag-charts-community";
import { getData } from "./data";

let symbolEnabled = true;
ModuleRegistry.registerModules(AllCommunityModule);

const options: AgCartesianChartOptions = {
  data: getData(),
  title: { text: "Monthly Temperatures" },
  series: [
    {
      type: "line",
      xKey: "month",
      yKey: "temperature",
      yName: "Temperature",
      tooltip: {
        renderer: () => {
          return {
            symbol: {
              marker: {
                enabled: symbolEnabled,
                shape: "star",
                fill: "#cc0000",
              },
              line: {
                enabled: symbolEnabled,
                stroke: "#ff6b00",
              },
            },
          };
        },
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function toggleSymbol() {
  symbolEnabled = !symbolEnabled;
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).toggleSymbol = toggleSymbol;
}
```

[Live example: Customising the Tooltip Symbol](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/tooltip-symbol/)

```js
{
    tooltip: {
        renderer: function () {
            return {
                symbol: {
                    marker: {
                        enabled: true,
                        shape: 'star',
                        fill: '#cc0000',
                    },
                    line: {
                        enabled: true,
                        stroke: '#ff6b00',
                    },
                },
            };
        },
    },
}
```

In this example:

- Click the button to toggle the symbol. This will take effect on the next hover.
- The `marker` shape has been changed to `'star'` instead of inheriting the circle shape from the series.
- The marker and line colours have been changed from those used in the series.

### Using Custom Tooltips

To use a completely custom tooltip instead of modifying the contents of the default tooltip template, return an HTML string to the `renderer` including all the markup required.

#### Column Series with Tooltip Renderer

```ts
import {
  AgBarSeriesTooltipRendererParams,
  AgChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";

function renderer(params: AgBarSeriesTooltipRendererParams<DataType>) {
  const { datum, fill, yKey } = params;
  return (
    '<div class="my-tooltip" style="--color:' +
    fill +
    '">' +
    datum.month +
    "&nbsp;&#10172;&nbsp;" +
    Number(datum[yKey]).toFixed(0) +
    "</div>"
  );
}
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgChartOptions<DataType> = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "month",
      tooltip: { renderer },
      yKey: "sweaters",
      yName: "Sweaters made",
      stacked: true,
    },
    {
      type: "bar",
      xKey: "month",
      tooltip: { renderer },
      yKey: "hats",
      yName: "Hats made",
      stacked: true,
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Column Series with Tooltip Renderer](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/tooltip-renderer/)

```js
{
    series: [
        {
            type: 'bar',
            tooltip: {
                renderer: function (params) {
                    return (
                        '<div class="my-tooltip" style="--color:' +
                        params.fill +
                        '">' +
                        params.datum[params.xKey] +
                        '&nbsp;&#10172;&nbsp;' +
                        params.datum[params.yKey].toFixed(0) +
                        '</div>'
                    );
                },
            },
        },
    ],
}
```

In this configuration:

- The `renderer` receives values associated with the highlighted data point. The actual type of the `params` object passed into the tooltip renderer will depend on the series type being used.
- The `renderer` returns a single HTML string.
- The text gets its colour from the `fill` property in the `params` object. This matches the colour of the series.
- The label comes from `params.datum[params.xKey]` which is the name of the month.
- The value comes from the `params.datum[params.yKey]`, which we then stringify as an integer via `toFixed(0)`.
- We used a custom class names on the returned `div` element, so that we can apply custom styling.

## Tooltip Range

The `tooltip.range` property specifies how near the cursor must be to a node for the tooltip to appear. This can be defined on each series, as well as on the chart level.

#### Tooltip Range

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  tooltip: {
    range: "nearest",
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "month",
      yKey: "value1",
      yName: "Sweaters Made",
    },
    {
      type: "line",
      xKey: "month",
      yKey: "hats_made",
      yName: "Hats Made",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setInteractionRange(event: Event) {
  switch ((event.target as HTMLInputElement).value) {
    case "nearest":
      options.tooltip = { range: "nearest" };
      break;
    case "exact":
      options.tooltip = { range: "exact" };
      break;
    case "distance":
      options.tooltip = { range: 10 };
      break;
  }

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setInteractionRange = setInteractionRange;
}
```

[Live example: Tooltip Range](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/interaction-range/)

Options for `tooltip.range` are:

- `'nearest'` - Always shows the tooltip of the nearest node. This is the default for marker-based series such as `line` and `scatter`.
- `'exact'` - Only shows the tooltip when the user hovers over a node. This is the default for shape-based series such as `bar` and `pie`.
- An integer - Only shows the tooltip when the cursor is within the specified pixel distance of a node.

## Interaction with Tooltips

#### Tooltip Interaction

```ts
import {
  AgBarSeriesTooltipRendererParams,
  AgCartesianChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";

function renderer(params: AgBarSeriesTooltipRendererParams<DataType>) {
  return `<div class="tooltip">
        <div class="tooltip-title">
            ${params.datum[params.xKey]}: ${params.datum[params.yKey]}
        </div>
        <div class="tooltip-body">
            <a tabindex="0" href="#" onclick="event.preventDefault(); console.log('Clicked within a tooltip')">Click here</a>
        </div>
    </div>`;
}
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions<DataType> = {
  data: getData(),
  series: [
    {
      type: "bar",
      xKey: "month",
      yKey: "sweaters",
      yName: "Sweaters Made",
      tooltip: {
        renderer,
        interaction: {
          enabled: true,
        },
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Tooltip Interaction](https://www.ag-grid.com/charts/archive/14.2.0/typescript/tooltips/examples/tooltip-interaction/)

By default, you cannot hover over a tooltip or select its text.

Set the `series[].tooltip.interaction.enabled` flag to `true` to enable selecting the text and clicking links within the tooltip.

## API Reference

#### Chart Tooltip Options

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Set to `false` to disable tooltips for all series in the chart. |
| mode | 'single' \| 'shared' \| 'compact' |  | Group multiple series into the same tooltip |
| showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. This will be used unless overridden by the series `tooltip.range` option. |
| position | AgTooltipPositionOptions |  | The position of the tooltip. This will be used unless overridden by the series `tooltip.range` option. |
| position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| pagination | boolean |  | The configuration for tooltip pagination. |
| delay | DurationMs |  | The time interval (in milliseconds) after which the tooltip is shown. |
| wrapping | 'never' \| 'always' \| 'hyphenate' \| 'on-space' | 'hyphenate' | Text wrapping strategy for tooltips. - `'always'` will always wrap text to fit within the tooltip. - `'hyphenate'` is similar to `'always'`, but inserts a hyphen (`-`) if forced to wrap in the middle of a word. - `'on-space'` will only wrap on white space. If there is no possibility to wrap a line on space and satisfy the tooltip dimensions, the text will be truncated. - `'never'` disables text wrapping. |

#### Series Tooltip Options

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether to show tooltips when the series are hovered over. |
| showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. Each series type uses its own default; typically this is `'nearest'` for marker-based series and `'exact'` for shape-based series. |
| position | AgTooltipPositionOptions |  | The position of the tooltip. Each series type uses its own default; typically this is `'node'` for marker-based series and `'pointer'` for shape-based series. |
| position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| interaction | AgSeriesTooltipInteraction |  | Configuration for tooltip interaction. |
| interaction.enabled (required) | boolean |  | Set to `true` to keep the tooltip open when the mouse is hovering over it, and enable clicking tooltip text |
| renderer | Renderer |  | Function used to create the content for tooltips. |


---
product: "AG Charts"
title: "Tooltips"
description: "Vue Chart Tooltips provide extra contextual information to Vue charts. Customise tooltips and control their position, range, arrow and interactivity."
framework: vue
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/series-highlighting/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Tooltips

Tooltips allow users to see extra contextual information without overcrowding the chart.

> **Note**
>
> This page covers Series tooltips. For tooltips on other chart elements, see the API options for [title](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-title-tooltip), [subtitle](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-subtitle-tooltip), [footnote](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-footnote-tooltip), and [legend items](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-legend-item-tooltip).

## Default Tooltip

The tooltip content is based on the data values and keys of the series. If provided, the `_Name` properties will be used instead of the `_Key` properties.

#### Default Tooltip

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group gap-right" role="group" aria-label="yNames">
          <input type="radio" id="ynames-remove" name="ynames" value="remove" v-on:change="yNamesChange($event)">
            <label for="ynames-remove">Remove yNames</label>
            <input type="radio" id="ynames-add" name="ynames" value="add" checked="" v-on:change="yNamesChange($event)">
              <label for="ynames-add">Add yNames</label>
            </div>
            <div class="button-group" role="group" aria-label="Series">
              <input type="radio" id="series-1" name="series-count" value="1" v-on:change="showNumSeries($event)">
                <label for="series-1">1 Series</label>
                <input type="radio" id="series-2" name="series-count" value="2" checked="" v-on:change="showNumSeries($event)">
                  <label for="series-2">2 Series</label>
                  <input type="radio" id="series-5" name="series-count" value="5" v-on:change="showNumSeries($event)">
                    <label for="series-5">5 Series</label>
                  </div>
                </div>
              </div>
              <ag-charts
                :options="options"
              />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "value1",
          yName: "Sweaters Made",
        },
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "hats_made",
          yName: "Hats Made",
        },
      ],
    });

    const yNamesChange = (event) => {
      const optionsCopy = clone(options.value);

      const yNames = [
        "Sweaters Made",
        "Hats Made",
        "Gloves Made",
        "Socks Made",
        "Sunglasses Made",
      ];
      const add = event.target.value === "add";
      optionsCopy.series?.forEach((series, index) => {
        series.yName = add ? yNames[index] : undefined;
      });

      options.value = optionsCopy;
    };
    const showNumSeries = (event) => {
      const optionsCopy = clone(options.value);

      const num = Number(event.target.value);
      const hasYNames = optionsCopy.series[0].yName != null;
      if (num === 1) {
        optionsCopy.series = [
          {
            type: "bar",
            xKey: "month",
            stacked: true,
            yKey: "value1",
            yName: "Sweaters Made",
          },
        ];
      } else if (num === 2) {
        optionsCopy.series = [
          {
            type: "bar",
            xKey: "month",
            stacked: true,
            yKey: "value1",
            yName: "Sweaters Made",
          },
          {
            type: "bar",
            xKey: "month",
            stacked: true,
            yKey: "hats_made",
            yName: "Hats Made",
          },
        ];
      } else {
        optionsCopy.series = [
          {
            type: "bar",
            xKey: "month",
            stacked: true,
            yKey: "value1",
            yName: "Sweaters Made",
          },
          {
            type: "bar",
            xKey: "month",
            stacked: true,
            yKey: "hats_made",
            yName: "Hats Made",
          },
          {
            type: "bar",
            xKey: "month",
            stacked: true,
            yKey: "gloves_made",
            yName: "Gloves Made",
          },
          {
            type: "bar",
            xKey: "month",
            stacked: true,
            yKey: "socks_made",
            yName: "Socks Made",
          },
          {
            type: "bar",
            xKey: "month",
            stacked: true,
            yKey: "sunglasses_made",
            yName: "Sunglasses Made",
          },
        ];
      }
      if (!hasYNames) {
        for (const series of optionsCopy.series ?? []) {
          series.yName = undefined;
        }
      }

      options.value = optionsCopy;
    };

    return {
      options,
      yNamesChange,
      showNumSeries,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Default Tooltip](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/default-tooltip/)

```js
{
    series: [
        { type: 'bar', xKey: 'month', stacked: true, yKey: 'value1', yName: 'Sweaters Made' },
        { type: 'bar', xKey: 'month', stacked: true, yKey: 'hats_made', yName: 'Hats Made' },
    ],
}
```

In this example:

- The `yName` is used in the tooltip and legend when provided.
- The default [tooltip mode](https://www.ag-grid.com/charts/archive/14.2.0/vue/tooltips/#tooltip-modes) is:
  - `compact` when showing a single series with no `yName`.
  - `single` when showing more than 3 series, or a single series with `yName`.
  - `shared` when showing 3 or fewer series.

The `_Name` keys mirror the data keys and differ between series types. See the series specific [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-series) for more details.

## Tooltip Modes

By default a shared tooltip will be used for most cartesian charts containing 3 or fewer series. Use the mode option to show a `single`, `shared` or `compact` tooltip.

#### Tooltip Mode

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Tooltip Mode">
          <input type="radio" id="tooltip-mode-single" name="tooltip-mode" value="single" checked="" v-on:change="setTooltipMode($event)">
            <label for="tooltip-mode-single">Single</label>
            <input type="radio" id="tooltip-mode-shared" name="tooltip-mode" value="shared" v-on:change="setTooltipMode($event)">
              <label for="tooltip-mode-shared">Shared</label>
              <input type="radio" id="tooltip-mode-compact" name="tooltip-mode" value="compact" v-on:change="setTooltipMode($event)">
                <label for="tooltip-mode-compact">Compact</label>
              </div>
            </div>
          </div>
          <ag-charts
            :options="options"
          />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      tooltip: {
        mode: "single",
      },
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "Onshore wind",
          yName: "Onshore Wind",
        },
        {
          type: "line",
          xKey: "year",
          yKey: "Offshore wind",
          yName: "Offshore Wind",
        },
        {
          type: "line",
          xKey: "year",
          yKey: "Solar photovoltaics",
          yName: "Solar Photovoltaics",
        },
        {
          type: "line",
          xKey: "year",
          yKey: "Plant biomass",
          yName: "Plant Biomass",
        },
        {
          type: "line",
          xKey: "year",
          yKey: "Landfill gas",
          yName: "Landfill Gas",
        },
      ],
      axes: {
        x: {
          type: "unit-time",
        },
        y: {
          position: "right",
          type: "number",
        },
      },
    });

    const setTooltipMode = (event) => {
      const optionsCopy = clone(options.value);

      optionsCopy.tooltip.mode = event.target.value;

      options.value = optionsCopy;
    };

    return {
      options,
      setTooltipMode,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Tooltip Mode](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/tooltip-mode/)

```js
{
    tooltip: {
        mode: 'shared', // or 'single' or 'compact'
    },
}
```

The options for `mode` are:

- `single` - shows a title, symbol and data values for a single series.
- `shared` - shows a merged tooltip, combining the tooltips of all series sharing the same x-value.
- `compact` - shows fewer data fields and uses less padding.

See [Highlight Modes](https://www.ag-grid.com/charts/archive/14.2.0/vue/series-highlighting/#highlight-modes) to apply the same shared grouping to series highlighting.

## Tooltip Position

By default the tooltip is anchored to the hovered datapoint. Use `placement`, `anchorTo` and `offset` to customise this.

#### Tooltip Position

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import type { AgTooltipAnchorTo, AgTooltipPlacement } from "ag-charts-types";
import clone from "clone";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <span>Anchor to:</span>
        <select class="gap-right" v-on:change="setAnchorTo($event.target.value)">
          <option value="node">Node</option>
          <option value="pointer">Pointer</option>
          <option value="chart">Chart</option>
        </select>
        <span>Placement:</span>
        <select class="gap-right" v-on:change="setPlacement($event.target.value)">
          <option value="top">Top</option>
          <option value="top-right">Top Right</option>
          <option value="right">Right</option>
          <option value="bottom-right">Bottom Right</option>
          <option value="bottom">Bottom</option>
          <option value="bottom-left">Bottom Left</option>
          <option value="left">Left</option>
          <option value="top-left">Top Left</option>
          <hr />
          <option value="left, right">Left + Right fallback</option>
          <option value="right, left">Right + Left fallback</option>
        </select>
        <label for="offsetSlider">Offset:</label>
        <input type="range" id="offsetSlider" min="0" max="40" value="12" v-on:input="setOffset($event)" v-on:change="setOffset($event)">
          <span id="offsetValue" style="display: inline-block; min-width: 3ch; text-align: right">12</span>
        </div>
      </div>
      <ag-charts
        :options="options"
      />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "month",
          yKey: "sweaters",
          yName: "Sweaters Made",
        },
      ],
      tooltip: {
        position: {
          placement: "top",
          offset: 12,
        },
      },
    });

    const setAnchorTo = (anchorTo) => {
      const optionsCopy = clone(options.value);

      optionsCopy.tooltip.position.anchorTo = anchorTo;

      options.value = optionsCopy;
    };
    const setPlacement = (placement) => {
      const optionsCopy = clone(options.value);

      optionsCopy.tooltip.position.placement = placement.split(/,\s+/g);

      options.value = optionsCopy;
    };
    const setOffset = (event) => {
      const optionsCopy = clone(options.value);

      const value = Number(event.target.value);
      document.getElementById("offsetValue").textContent = String(value);
      optionsCopy.tooltip.position.offset = value;

      options.value = optionsCopy;
    };

    return {
      options,
      setAnchorTo,
      setPlacement,
      setOffset,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Tooltip Position](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/tooltip-position/)

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['top', 'bottom', 'left', 'right'],
            offset: 12,
        },
    },
}
```

### Placement

The `placement` option positions the tooltip relative to its [anchor point](https://www.ag-grid.com/charts/archive/14.2.0/vue/tooltips/#anchor-point), such as `top` or `top-right`. See the [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/vue/tooltips/#reference-AgChartTooltipOptions-position-placement) for the full list of values.

Fallback positions can be provided in an array of `placement` values. The tooltip will use the first position that has sufficient space.

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['left', 'right'],
        },
    },
}
```

In the above example:

- Change the 'Placement' dropdown to 'Left + Right fallback'.
- Hover the leftmost datapoint and see that the tooltip goes to the right of the marker as there is no room on the left.

### Anchor Point

The options for `anchorTo` are:

- `node` - the active datapoint, such as the marker or bar.
- `pointer` - the mouse pointer or [single finger touch](https://www.ag-grid.com/charts/archive/14.2.0/vue/touch/#single-finger-touch-dragging) position.
- `chart` - the chart container.

### Offset

Use `tooltip.position.offset` to control the gap between the tooltip and its anchor point in the placement direction, or `xOffset` and `yOffset` for specific horizontal and vertical offsets.

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['right', 'left'],
            offset: 20,
        },
    },
}
```

In the above example:

- Change the 'Placement' dropdown to 'Left + Right fallback' and change the 'Offset' value.
- Hover the leftmost datapoint and see that the offset is applied to the right of the marker, hover the rightmost datapoint and see that the offset is applied to the left.
- The directional `offset` can be used together with `xOffset` and `yOffset`.

## Tooltip Arrow

The default tooltip displays an arrow below it to indicate its exact point of origin. This is removed when the tooltip is constrained by the container or has an `xOffset` or `yOffset` supplied. The directional `offset` does not suppress the arrow.

#### Removing the Tooltip Arrow

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button v-on:click="toggleTooltipArrow()">Toggle Tooltip Arrow</button>
      </div>
    </div>
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "value1",
          yName: "Sweaters Made",
        },
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "hats_made",
          yName: "Hats Made",
        },
      ],
      tooltip: {
        showArrow: true,
      },
    });

    const toggleTooltipArrow = () => {
      const optionsCopy = clone(options.value);

      optionsCopy.tooltip.showArrow = !optionsCopy.tooltip.showArrow;

      options.value = optionsCopy;
    };

    return {
      options,
      toggleTooltipArrow,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Removing the Tooltip Arrow](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/default-tooltip-arrow/)

Use the `tooltip.showArrow` option to change this behaviour.

```js
{
    tooltip: {
        showArrow: false,
    },
}
```

## Tooltip Pagination

Pagination allows cycling through overlapping datapoints by hovering and then clicking on the mouse. Use `pagination: true` to enable.

#### Tooltip Pagination

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BubbleSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BubbleSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions<DataType>>({
      data: getData(),
      title: {
        text: "Most Populous Cities",
      },
      footnote: {
        text: "Source: Simple Maps",
      },
      series: [
        {
          type: "bubble",
          title: "Most populous cities",
          xKey: "lon",
          xName: "Longitude",
          yKey: "lat",
          yName: "Latitude",
          sizeKey: "population",
          sizeName: "Population",
          labelKey: "city",
          labelName: "City",
          maxSize: 50,
          tooltip: {
            renderer: ({ datum }) => ({ title: datum.city }),
          },
        },
      ],
      tooltip: {
        pagination: true,
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Tooltip Pagination](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/tooltip-pagination/)

Pagination will only become available when two or more data points are under the cursor.

```js
{
    tooltip: {
        pagination: true,
    },
}
```

In the above example:

- Hover overlapping bubbles.
- The cursor turns into a hand and the tooltip displays the number of data points under the cursor.
- Click in the current position to cycle through the data points, highlighting and displaying the tooltip for each in turn.

## Customisation

The exact contents and structure of a tooltip depends on the series and keys used.

Tooltips can contain any number of the following items, in order:-

- A heading - typically the x-value for a cartesian series.
- A series symbol - this graphically depicts a series and usually matches the legend item.
- A title - typically the identifying value for non-cartesian series.
- Some data rows - these contain one or more label and value pairs corresponding to information for a series.

### Using CSS Styles

#### Default Tooltip with Custom Styling

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "month",
          yKey: "sweaters",
          yName: "Sweaters Made",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Default Tooltip with Custom Styling](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/default-tooltip-styling/)

The default tooltip uses the following CSS classes for the tooltip elements:

- `ag-charts-tooltip` for the entire tooltip container.
- `ag-charts-tooltip-heading` and `ag-charts-tooltip-title` for the tooltip headings and titles.
- `ag-charts-tooltip-symbol` for the series symbol.
- `ag-charts-tooltip-label` and `ag-charts-tooltip-value` for the elements in the data rows.

Adding custom CSS to these will change the styling of all the tooltips in your app.

```css
.ag-charts-tooltip {
    background-color: papayawhip;
    border: 2px solid peachpuff;
    color: maroon;
}

.ag-charts-tooltip-heading {
    font-weight: bold;
}
```

Note that your styles don't override the default tooltip styles but complement them.

### Modifying Content

The tooltip's content can be customised within the default template by using a `renderer` callback function.

#### Modifying Tooltip Content

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

function renderer({ datum, yKey, yName }) {
  return {
    heading: "Clothing Production",
    title: yName?.toUpperCase(),
    data: [
      {
        label: datum.month,
        value: Number(datum[yKey]).toFixed(1),
      },
    ],
  };
}

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions<DataType>>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "month",
          tooltip: { renderer },
          yKey: "sweaters",
          yName: "Sweaters made",
          stacked: true,
        },
        {
          type: "bar",
          xKey: "month",
          tooltip: { renderer },
          yKey: "hats",
          yName: "Hats made",
          stacked: true,
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Modifying Tooltip Content](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/tooltip-content-title/)

```js
{
    tooltip: {
        renderer: function ({ datum, xKey, yKey, yName }) {
            return {
                heading: 'Clothing Production',
                title: yName.toUpperCase(),
                data: [
                    {
                        label: datum[xKey],
                        value: datum[yKey].toFixed(1),
                    },
                ],
            };
        },
    },
}
```

In this configuration:

- The `renderer` receives values associated with the highlighted data point. The actual type of the `params` object passed into the tooltip renderer will depend on the series type being used.
- The `renderer` returns an object with optional `heading`, `title`, `symbol`, and `data` fields.
- The `heading` and `title` must be plain text.
- The `data` field consists of an array of `label` and `value` fields, which are both plain text.
- Returning an empty string for any field will cause it to be omitted from the rendered tooltip.

### Modifying the Symbol

The tooltip symbol (the coloured marker that represents the series) can be customised using the `symbol` property in the renderer's return object.

Whether the symbol defaults to use a `marker`, `line`, or both depends on the series type and options used. Use the `enabled` option for each element to override this.

#### Customising the Tooltip Symbol

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import { AllCommunityModule, ModuleRegistry } from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

let symbolEnabled = true;

ModuleRegistry.registerModules(AllCommunityModule);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button v-on:click="toggleSymbol()">Toggle Symbol</button>
      </div>
    </div>
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      title: { text: "Monthly Temperatures" },
      series: [
        {
          type: "line",
          xKey: "month",
          yKey: "temperature",
          yName: "Temperature",
          tooltip: {
            renderer: () => {
              return {
                symbol: {
                  marker: {
                    enabled: symbolEnabled,
                    shape: "star",
                    fill: "#cc0000",
                  },
                  line: {
                    enabled: symbolEnabled,
                    stroke: "#ff6b00",
                  },
                },
              };
            },
          },
        },
      ],
    });

    const toggleSymbol = () => {
      symbolEnabled = !symbolEnabled;
    };

    return {
      options,
      toggleSymbol,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Customising the Tooltip Symbol](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/tooltip-symbol/)

```js
{
    tooltip: {
        renderer: function () {
            return {
                symbol: {
                    marker: {
                        enabled: true,
                        shape: 'star',
                        fill: '#cc0000',
                    },
                    line: {
                        enabled: true,
                        stroke: '#ff6b00',
                    },
                },
            };
        },
    },
}
```

In this example:

- Click the button to toggle the symbol. This will take effect on the next hover.
- The `marker` shape has been changed to `'star'` instead of inheriting the circle shape from the series.
- The marker and line colours have been changed from those used in the series.

### Using Custom Tooltips

To use a completely custom tooltip instead of modifying the contents of the default tooltip template, return an HTML string to the `renderer` including all the markup required.

#### Column Series with Tooltip Renderer

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

function renderer(params) {
  const { datum, fill, yKey } = params;
  return (
    '<div class="my-tooltip" style="--color:' +
    fill +
    '">' +
    datum.month +
    "&nbsp;&#10172;&nbsp;" +
    Number(datum[yKey]).toFixed(0) +
    "</div>"
  );
}

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions<DataType>>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "month",
          tooltip: { renderer },
          yKey: "sweaters",
          yName: "Sweaters made",
          stacked: true,
        },
        {
          type: "bar",
          xKey: "month",
          tooltip: { renderer },
          yKey: "hats",
          yName: "Hats made",
          stacked: true,
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Column Series with Tooltip Renderer](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/tooltip-renderer/)

```js
{
    series: [
        {
            type: 'bar',
            tooltip: {
                renderer: function (params) {
                    return (
                        '<div class="my-tooltip" style="--color:' +
                        params.fill +
                        '">' +
                        params.datum[params.xKey] +
                        '&nbsp;&#10172;&nbsp;' +
                        params.datum[params.yKey].toFixed(0) +
                        '</div>'
                    );
                },
            },
        },
    ],
}
```

In this configuration:

- The `renderer` receives values associated with the highlighted data point. The actual type of the `params` object passed into the tooltip renderer will depend on the series type being used.
- The `renderer` returns a single HTML string.
- The text gets its colour from the `fill` property in the `params` object. This matches the colour of the series.
- The label comes from `params.datum[params.xKey]` which is the name of the month.
- The value comes from the `params.datum[params.yKey]`, which we then stringify as an integer via `toFixed(0)`.
- We used a custom class names on the returned `div` element, so that we can apply custom styling.

## Tooltip Range

The `tooltip.range` property specifies how near the cursor must be to a node for the tooltip to appear. This can be defined on each series, as well as on the chart level.

#### Tooltip Range

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Interaction Range">
          <input type="radio" id="interaction-range-nearest" name="interaction-range" value="nearest" checked="" v-on:change="setInteractionRange($event)">
            <label for="interaction-range-nearest">Nearest</label>
            <input type="radio" id="interaction-range-exact" name="interaction-range" value="exact" v-on:change="setInteractionRange($event)">
              <label for="interaction-range-exact">Exact</label>
              <input type="radio" id="interaction-range-distance" name="interaction-range" value="distance" v-on:change="setInteractionRange($event)">
                <label for="interaction-range-distance">Distance (10 Pixels)</label>
              </div>
            </div>
          </div>
          <ag-charts
            :options="options"
          />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      tooltip: {
        range: "nearest",
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "month",
          yKey: "value1",
          yName: "Sweaters Made",
        },
        {
          type: "line",
          xKey: "month",
          yKey: "hats_made",
          yName: "Hats Made",
        },
      ],
    });

    const setInteractionRange = (event) => {
      const optionsCopy = clone(options.value);

      switch (event.target.value) {
        case "nearest":
          optionsCopy.tooltip = { range: "nearest" };
          break;
        case "exact":
          optionsCopy.tooltip = { range: "exact" };
          break;
        case "distance":
          optionsCopy.tooltip = { range: 10 };
          break;
      }

      options.value = optionsCopy;
    };

    return {
      options,
      setInteractionRange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Tooltip Range](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/interaction-range/)

Options for `tooltip.range` are:

- `'nearest'` - Always shows the tooltip of the nearest node. This is the default for marker-based series such as `line` and `scatter`.
- `'exact'` - Only shows the tooltip when the user hovers over a node. This is the default for shape-based series such as `bar` and `pie`.
- An integer - Only shows the tooltip when the cursor is within the specified pixel distance of a node.

## Interaction with Tooltips

#### Tooltip Interaction

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

function renderer(params) {
  return `<div class="tooltip">
        <div class="tooltip-title">
            ${params.datum[params.xKey]}: ${params.datum[params.yKey]}
        </div>
        <div class="tooltip-body">
            <a tabindex="0" href="#" onclick="event.preventDefault(); console.log('Clicked within a tooltip')">Click here</a>
        </div>
    </div>`;
}

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions<DataType>>({
      data: getData(),
      series: [
        {
          type: "bar",
          xKey: "month",
          yKey: "sweaters",
          yName: "Sweaters Made",
          tooltip: {
            renderer,
            interaction: {
              enabled: true,
            },
          },
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Tooltip Interaction](https://www.ag-grid.com/charts/archive/14.2.0/vue3/tooltips/examples/tooltip-interaction/)

By default, you cannot hover over a tooltip or select its text.

Set the `series[].tooltip.interaction.enabled` flag to `true` to enable selecting the text and clicking links within the tooltip.

## API Reference

#### Chart Tooltip Options

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Set to `false` to disable tooltips for all series in the chart. |
| mode | 'single' \| 'shared' \| 'compact' |  | Group multiple series into the same tooltip |
| showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. This will be used unless overridden by the series `tooltip.range` option. |
| position | AgTooltipPositionOptions |  | The position of the tooltip. This will be used unless overridden by the series `tooltip.range` option. |
| position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| pagination | boolean |  | The configuration for tooltip pagination. |
| delay | DurationMs |  | The time interval (in milliseconds) after which the tooltip is shown. |
| wrapping | 'never' \| 'always' \| 'hyphenate' \| 'on-space' | 'hyphenate' | Text wrapping strategy for tooltips. - `'always'` will always wrap text to fit within the tooltip. - `'hyphenate'` is similar to `'always'`, but inserts a hyphen (`-`) if forced to wrap in the middle of a word. - `'on-space'` will only wrap on white space. If there is no possibility to wrap a line on space and satisfy the tooltip dimensions, the text will be truncated. - `'never'` disables text wrapping. |

#### Series Tooltip Options

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether to show tooltips when the series are hovered over. |
| showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. Each series type uses its own default; typically this is `'nearest'` for marker-based series and `'exact'` for shape-based series. |
| position | AgTooltipPositionOptions |  | The position of the tooltip. Each series type uses its own default; typically this is `'node'` for marker-based series and `'pointer'` for shape-based series. |
| position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| interaction | AgSeriesTooltipInteraction |  | Configuration for tooltip interaction. |
| interaction.enabled (required) | boolean |  | Set to `true` to keep the tooltip open when the mouse is hovering over it, and enable clicking tooltip text |
| renderer | Renderer |  | Function used to create the content for tooltips. |


---
product: "AG Charts"
title: "Tooltips"
description: "Angular Chart Tooltips provide extra contextual information to Angular charts. Customise tooltips and control their position, range, arrow and interactivity."
framework: angular
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/series-highlighting/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Tooltips

Tooltips allow users to see extra contextual information without overcrowding the chart.

> **Note**
>
> This page covers Series tooltips. For tooltips on other chart elements, see the API options for [title](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-title-tooltip), [subtitle](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-subtitle-tooltip), [footnote](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-footnote-tooltip), and [legend items](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-legend-item-tooltip).

## Default Tooltip

The tooltip content is based on the data values and keys of the series. If provided, the `_Name` properties will be used instead of the `_Key` properties.

#### Default Tooltip

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Default Tooltip](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/default-tooltip/)

```js
{
    series: [
        { type: 'bar', xKey: 'month', stacked: true, yKey: 'value1', yName: 'Sweaters Made' },
        { type: 'bar', xKey: 'month', stacked: true, yKey: 'hats_made', yName: 'Hats Made' },
    ],
}
```

In this example:

- The `yName` is used in the tooltip and legend when provided.
- The default [tooltip mode](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/#tooltip-modes) is:
  - `compact` when showing a single series with no `yName`.
  - `single` when showing more than 3 series, or a single series with `yName`.
  - `shared` when showing 3 or fewer series.

The `_Name` keys mirror the data keys and differ between series types. See the series specific [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-series) for more details.

## Tooltip Modes

By default a shared tooltip will be used for most cartesian charts containing 3 or fewer series. Use the mode option to show a `single`, `shared` or `compact` tooltip.

#### Tooltip Mode

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Tooltip Mode](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/tooltip-mode/)

```js
{
    tooltip: {
        mode: 'shared', // or 'single' or 'compact'
    },
}
```

The options for `mode` are:

- `single` - shows a title, symbol and data values for a single series.
- `shared` - shows a merged tooltip, combining the tooltips of all series sharing the same x-value.
- `compact` - shows fewer data fields and uses less padding.

See [Highlight Modes](https://www.ag-grid.com/charts/archive/14.2.0/angular/series-highlighting/#highlight-modes) to apply the same shared grouping to series highlighting.

## Tooltip Position

By default the tooltip is anchored to the hovered datapoint. Use `placement`, `anchorTo` and `offset` to customise this.

#### Tooltip Position

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Tooltip Position](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/tooltip-position/)

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['top', 'bottom', 'left', 'right'],
            offset: 12,
        },
    },
}
```

### Placement

The `placement` option positions the tooltip relative to its [anchor point](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/#anchor-point), such as `top` or `top-right`. See the [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/#reference-AgChartTooltipOptions-position-placement) for the full list of values.

Fallback positions can be provided in an array of `placement` values. The tooltip will use the first position that has sufficient space.

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['left', 'right'],
        },
    },
}
```

In the above example:

- Change the 'Placement' dropdown to 'Left + Right fallback'.
- Hover the leftmost datapoint and see that the tooltip goes to the right of the marker as there is no room on the left.

### Anchor Point

The options for `anchorTo` are:

- `node` - the active datapoint, such as the marker or bar.
- `pointer` - the mouse pointer or [single finger touch](https://www.ag-grid.com/charts/archive/14.2.0/angular/touch/#single-finger-touch-dragging) position.
- `chart` - the chart container.

### Offset

Use `tooltip.position.offset` to control the gap between the tooltip and its anchor point in the placement direction, or `xOffset` and `yOffset` for specific horizontal and vertical offsets.

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['right', 'left'],
            offset: 20,
        },
    },
}
```

In the above example:

- Change the 'Placement' dropdown to 'Left + Right fallback' and change the 'Offset' value.
- Hover the leftmost datapoint and see that the offset is applied to the right of the marker, hover the rightmost datapoint and see that the offset is applied to the left.
- The directional `offset` can be used together with `xOffset` and `yOffset`.

## Tooltip Arrow

The default tooltip displays an arrow below it to indicate its exact point of origin. This is removed when the tooltip is constrained by the container or has an `xOffset` or `yOffset` supplied. The directional `offset` does not suppress the arrow.

#### Removing the Tooltip Arrow

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Removing the Tooltip Arrow](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/default-tooltip-arrow/)

Use the `tooltip.showArrow` option to change this behaviour.

```js
{
    tooltip: {
        showArrow: false,
    },
}
```

## Tooltip Pagination

Pagination allows cycling through overlapping datapoints by hovering and then clicking on the mouse. Use `pagination: true` to enable.

#### Tooltip Pagination

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Tooltip Pagination](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/tooltip-pagination/)

Pagination will only become available when two or more data points are under the cursor.

```js
{
    tooltip: {
        pagination: true,
    },
}
```

In the above example:

- Hover overlapping bubbles.
- The cursor turns into a hand and the tooltip displays the number of data points under the cursor.
- Click in the current position to cycle through the data points, highlighting and displaying the tooltip for each in turn.

## Customisation

The exact contents and structure of a tooltip depends on the series and keys used.

Tooltips can contain any number of the following items, in order:-

- A heading - typically the x-value for a cartesian series.
- A series symbol - this graphically depicts a series and usually matches the legend item.
- A title - typically the identifying value for non-cartesian series.
- Some data rows - these contain one or more label and value pairs corresponding to information for a series.

### Using CSS Styles

#### Default Tooltip with Custom Styling

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Default Tooltip with Custom Styling](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/default-tooltip-styling/)

The default tooltip uses the following CSS classes for the tooltip elements:

- `ag-charts-tooltip` for the entire tooltip container.
- `ag-charts-tooltip-heading` and `ag-charts-tooltip-title` for the tooltip headings and titles.
- `ag-charts-tooltip-symbol` for the series symbol.
- `ag-charts-tooltip-label` and `ag-charts-tooltip-value` for the elements in the data rows.

Adding custom CSS to these will change the styling of all the tooltips in your app.

```css
.ag-charts-tooltip {
    background-color: papayawhip;
    border: 2px solid peachpuff;
    color: maroon;
}

.ag-charts-tooltip-heading {
    font-weight: bold;
}
```

Note that your styles don't override the default tooltip styles but complement them.

### Modifying Content

The tooltip's content can be customised within the default template by using a `renderer` callback function.

#### Modifying Tooltip Content

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Modifying Tooltip Content](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/tooltip-content-title/)

```js
{
    tooltip: {
        renderer: function ({ datum, xKey, yKey, yName }) {
            return {
                heading: 'Clothing Production',
                title: yName.toUpperCase(),
                data: [
                    {
                        label: datum[xKey],
                        value: datum[yKey].toFixed(1),
                    },
                ],
            };
        },
    },
}
```

In this configuration:

- The `renderer` receives values associated with the highlighted data point. The actual type of the `params` object passed into the tooltip renderer will depend on the series type being used.
- The `renderer` returns an object with optional `heading`, `title`, `symbol`, and `data` fields.
- The `heading` and `title` must be plain text.
- The `data` field consists of an array of `label` and `value` fields, which are both plain text.
- Returning an empty string for any field will cause it to be omitted from the rendered tooltip.

### Modifying the Symbol

The tooltip symbol (the coloured marker that represents the series) can be customised using the `symbol` property in the renderer's return object.

Whether the symbol defaults to use a `marker`, `line`, or both depends on the series type and options used. Use the `enabled` option for each element to override this.

#### Customising the Tooltip Symbol

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Customising the Tooltip Symbol](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/tooltip-symbol/)

```js
{
    tooltip: {
        renderer: function () {
            return {
                symbol: {
                    marker: {
                        enabled: true,
                        shape: 'star',
                        fill: '#cc0000',
                    },
                    line: {
                        enabled: true,
                        stroke: '#ff6b00',
                    },
                },
            };
        },
    },
}
```

In this example:

- Click the button to toggle the symbol. This will take effect on the next hover.
- The `marker` shape has been changed to `'star'` instead of inheriting the circle shape from the series.
- The marker and line colours have been changed from those used in the series.

### Using Custom Tooltips

To use a completely custom tooltip instead of modifying the contents of the default tooltip template, return an HTML string to the `renderer` including all the markup required.

#### Column Series with Tooltip Renderer

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Column Series with Tooltip Renderer](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/tooltip-renderer/)

```js
{
    series: [
        {
            type: 'bar',
            tooltip: {
                renderer: function (params) {
                    return (
                        '<div class="my-tooltip" style="--color:' +
                        params.fill +
                        '">' +
                        params.datum[params.xKey] +
                        '&nbsp;&#10172;&nbsp;' +
                        params.datum[params.yKey].toFixed(0) +
                        '</div>'
                    );
                },
            },
        },
    ],
}
```

In this configuration:

- The `renderer` receives values associated with the highlighted data point. The actual type of the `params` object passed into the tooltip renderer will depend on the series type being used.
- The `renderer` returns a single HTML string.
- The text gets its colour from the `fill` property in the `params` object. This matches the colour of the series.
- The label comes from `params.datum[params.xKey]` which is the name of the month.
- The value comes from the `params.datum[params.yKey]`, which we then stringify as an integer via `toFixed(0)`.
- We used a custom class names on the returned `div` element, so that we can apply custom styling.

## Tooltip Range

The `tooltip.range` property specifies how near the cursor must be to a node for the tooltip to appear. This can be defined on each series, as well as on the chart level.

#### Tooltip Range

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Tooltip Range](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/interaction-range/)

Options for `tooltip.range` are:

- `'nearest'` - Always shows the tooltip of the nearest node. This is the default for marker-based series such as `line` and `scatter`.
- `'exact'` - Only shows the tooltip when the user hovers over a node. This is the default for shape-based series such as `bar` and `pie`.
- An integer - Only shows the tooltip when the cursor is within the specified pixel distance of a node.

## Interaction with Tooltips

#### Tooltip Interaction

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Tooltip Interaction](https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/examples/tooltip-interaction/)

By default, you cannot hover over a tooltip or select its text.

Set the `series[].tooltip.interaction.enabled` flag to `true` to enable selecting the text and clicking links within the tooltip.

## API Reference

#### Chart Tooltip Options

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Set to `false` to disable tooltips for all series in the chart. |
| mode | 'single' \| 'shared' \| 'compact' |  | Group multiple series into the same tooltip |
| showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. This will be used unless overridden by the series `tooltip.range` option. |
| position | AgTooltipPositionOptions |  | The position of the tooltip. This will be used unless overridden by the series `tooltip.range` option. |
| position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| pagination | boolean |  | The configuration for tooltip pagination. |
| delay | DurationMs |  | The time interval (in milliseconds) after which the tooltip is shown. |
| wrapping | 'never' \| 'always' \| 'hyphenate' \| 'on-space' | 'hyphenate' | Text wrapping strategy for tooltips. - `'always'` will always wrap text to fit within the tooltip. - `'hyphenate'` is similar to `'always'`, but inserts a hyphen (`-`) if forced to wrap in the middle of a word. - `'on-space'` will only wrap on white space. If there is no possibility to wrap a line on space and satisfy the tooltip dimensions, the text will be truncated. - `'never'` disables text wrapping. |

#### Series Tooltip Options

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether to show tooltips when the series are hovered over. |
| showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. Each series type uses its own default; typically this is `'nearest'` for marker-based series and `'exact'` for shape-based series. |
| position | AgTooltipPositionOptions |  | The position of the tooltip. Each series type uses its own default; typically this is `'node'` for marker-based series and `'pointer'` for shape-based series. |
| position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| interaction | AgSeriesTooltipInteraction |  | Configuration for tooltip interaction. |
| interaction.enabled (required) | boolean |  | Set to `true` to keep the tooltip open when the mouse is hovering over it, and enable clicking tooltip text |
| renderer | Renderer |  | Function used to create the content for tooltips. |


---
product: "AG Charts"
title: "Tooltips"
description: "React Chart Tooltips provide extra contextual information to React charts. Customise tooltips and control their position, range, arrow and interactivity."
framework: react
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/series-highlighting/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/sync/"
    - title: "Zoom"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Tooltips

Tooltips allow users to see extra contextual information without overcrowding the chart.

> **Note**
>
> This page covers Series tooltips. For tooltips on other chart elements, see the API options for [title](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-title-tooltip), [subtitle](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-subtitle-tooltip), [footnote](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-footnote-tooltip), and [legend items](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-legend-item-tooltip).

## Default Tooltip

The tooltip content is based on the data values and keys of the series. If provided, the `_Name` properties will be used instead of the `_Key` properties.

#### Default Tooltip

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgBarSeriesOptions,
  AgCartesianChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "value1",
        yName: "Sweaters Made",
      },
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "hats_made",
        yName: "Hats Made",
      },
    ],
  });

  const yNamesChange = (event: Event) => {
    const nextOptions = clone(options);

    const yNames = [
      "Sweaters Made",
      "Hats Made",
      "Gloves Made",
      "Socks Made",
      "Sunglasses Made",
    ];
    const add = (event.target as HTMLInputElement).value === "add";
    nextOptions.series?.forEach((series, index) => {
      (series as AgBarSeriesOptions).yName = add ? yNames[index] : undefined;
    });

    setOptions(nextOptions);
  };

  const showNumSeries = (event: Event) => {
    const nextOptions = clone(options);

    const num = Number((event.target as HTMLInputElement).value);
    const hasYNames =
      (nextOptions.series![0] as AgBarSeriesOptions).yName != null;
    if (num === 1) {
      nextOptions.series = [
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "value1",
          yName: "Sweaters Made",
        },
      ];
    } else if (num === 2) {
      nextOptions.series = [
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "value1",
          yName: "Sweaters Made",
        },
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "hats_made",
          yName: "Hats Made",
        },
      ];
    } else {
      nextOptions.series = [
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "value1",
          yName: "Sweaters Made",
        },
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "hats_made",
          yName: "Hats Made",
        },
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "gloves_made",
          yName: "Gloves Made",
        },
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "socks_made",
          yName: "Socks Made",
        },
        {
          type: "bar",
          xKey: "month",
          stacked: true,
          yKey: "sunglasses_made",
          yName: "Sunglasses Made",
        },
      ];
    }
    if (!hasYNames) {
      for (const series of nextOptions.series ?? []) {
        (series as AgBarSeriesOptions).yName = undefined;
      }
    }

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div
            className="button-group gap-right"
            role="group"
            aria-label="yNames"
          >
            <input
              type="radio"
              id="ynames-remove"
              name="ynames"
              defaultValue="remove"
              onChange={(event) => yNamesChange(event)}
            />
            <label htmlFor="ynames-remove">Remove yNames</label>
            <input
              type="radio"
              id="ynames-add"
              name="ynames"
              defaultValue="add"
              defaultChecked
              onChange={(event) => yNamesChange(event)}
            />
            <label htmlFor="ynames-add">Add yNames</label>
          </div>
          <div className="button-group" role="group" aria-label="Series">
            <input
              type="radio"
              id="series-1"
              name="series-count"
              defaultValue="1"
              onChange={(event) => showNumSeries(event)}
            />
            <label htmlFor="series-1">1 Series</label>
            <input
              type="radio"
              id="series-2"
              name="series-count"
              defaultValue="2"
              defaultChecked
              onChange={(event) => showNumSeries(event)}
            />
            <label htmlFor="series-2">2 Series</label>
            <input
              type="radio"
              id="series-5"
              name="series-count"
              defaultValue="5"
              onChange={(event) => showNumSeries(event)}
            />
            <label htmlFor="series-5">5 Series</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Default Tooltip](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/default-tooltip/)

```js
{
    series: [
        { type: 'bar', xKey: 'month', stacked: true, yKey: 'value1', yName: 'Sweaters Made' },
        { type: 'bar', xKey: 'month', stacked: true, yKey: 'hats_made', yName: 'Hats Made' },
    ],
}
```

In this example:

- The `yName` is used in the tooltip and legend when provided.
- The default [tooltip mode](https://www.ag-grid.com/charts/archive/14.2.0/react/tooltips/#tooltip-modes) is:
  - `compact` when showing a single series with no `yName`.
  - `single` when showing more than 3 series, or a single series with `yName`.
  - `shared` when showing 3 or fewer series.

The `_Name` keys mirror the data keys and differ between series types. See the series specific [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/#reference-AgChartOptions-series) for more details.

## Tooltip Modes

By default a shared tooltip will be used for most cartesian charts containing 3 or fewer series. Use the mode option to show a `single`, `shared` or `compact` tooltip.

#### Tooltip Mode

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgTooltipMode,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    tooltip: {
      mode: "single",
    },
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "Onshore wind",
        yName: "Onshore Wind",
      },
      {
        type: "line",
        xKey: "year",
        yKey: "Offshore wind",
        yName: "Offshore Wind",
      },
      {
        type: "line",
        xKey: "year",
        yKey: "Solar photovoltaics",
        yName: "Solar Photovoltaics",
      },
      {
        type: "line",
        xKey: "year",
        yKey: "Plant biomass",
        yName: "Plant Biomass",
      },
      {
        type: "line",
        xKey: "year",
        yKey: "Landfill gas",
        yName: "Landfill Gas",
      },
    ],
    axes: {
      x: {
        type: "unit-time",
      },
      y: {
        position: "right",
        type: "number",
      },
    },
  });

  const setTooltipMode = (event: Event) => {
    const nextOptions = clone(options);

    nextOptions.tooltip!.mode = (event.target as HTMLInputElement)
      .value as AgTooltipMode;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div className="button-group" role="group" aria-label="Tooltip Mode">
            <input
              type="radio"
              id="tooltip-mode-single"
              name="tooltip-mode"
              defaultValue="single"
              defaultChecked
              onChange={(event) => setTooltipMode(event)}
            />
            <label htmlFor="tooltip-mode-single">Single</label>
            <input
              type="radio"
              id="tooltip-mode-shared"
              name="tooltip-mode"
              defaultValue="shared"
              onChange={(event) => setTooltipMode(event)}
            />
            <label htmlFor="tooltip-mode-shared">Shared</label>
            <input
              type="radio"
              id="tooltip-mode-compact"
              name="tooltip-mode"
              defaultValue="compact"
              onChange={(event) => setTooltipMode(event)}
            />
            <label htmlFor="tooltip-mode-compact">Compact</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Tooltip Mode](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/tooltip-mode/)

```js
{
    tooltip: {
        mode: 'shared', // or 'single' or 'compact'
    },
}
```

The options for `mode` are:

- `single` - shows a title, symbol and data values for a single series.
- `shared` - shows a merged tooltip, combining the tooltips of all series sharing the same x-value.
- `compact` - shows fewer data fields and uses less padding.

See [Highlight Modes](https://www.ag-grid.com/charts/archive/14.2.0/react/series-highlighting/#highlight-modes) to apply the same shared grouping to series highlighting.

## Tooltip Position

By default the tooltip is anchored to the hovered datapoint. Use `placement`, `anchorTo` and `offset` to customise this.

#### Tooltip Position

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { AgTooltipAnchorTo, AgTooltipPlacement } from "ag-charts-types";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "month",
        yKey: "sweaters",
        yName: "Sweaters Made",
      },
    ],
    tooltip: {
      position: {
        placement: "top",
        offset: 12,
      },
    },
  });

  const setAnchorTo = (anchorTo: AgTooltipAnchorTo) => {
    const nextOptions = clone(options);

    nextOptions.tooltip!.position!.anchorTo = anchorTo;

    setOptions(nextOptions);
  };

  const setPlacement = (placement: string) => {
    const nextOptions = clone(options);

    nextOptions.tooltip!.position!.placement = placement.split(
      /,\s+/g,
    ) as AgTooltipPlacement[];

    setOptions(nextOptions);
  };

  const setOffset = (event: Event) => {
    const nextOptions = clone(options);

    const value = Number((event.target as HTMLInputElement).value);
    document.getElementById("offsetValue")!.textContent = String(value);
    nextOptions.tooltip!.position!.offset = value;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <span>Anchor to:</span>
          <select
            className="gap-right"
            onChange={(event) => setAnchorTo(event.target.value)}
          >
            <option value="node">Node</option>
            <option value="pointer">Pointer</option>
            <option value="chart">Chart</option>
          </select>
          <span>Placement:</span>
          <select
            className="gap-right"
            onChange={(event) => setPlacement(event.target.value)}
          >
            <option value="top">Top</option>
            <option value="top-right">Top Right</option>
            <option value="right">Right</option>
            <option value="bottom-right">Bottom Right</option>
            <option value="bottom">Bottom</option>
            <option value="bottom-left">Bottom Left</option>
            <option value="left">Left</option>
            <option value="top-left">Top Left</option>
            <hr />
            <option value="left, right">Left + Right fallback</option>
            <option value="right, left">Right + Left fallback</option>
          </select>
          <label htmlFor="offsetSlider">Offset:</label>
          <input
            type="range"
            id="offsetSlider"
            min="0"
            max="40"
            defaultValue="12"
            onInput={(event) => setOffset(event)}
            onChange={(event) => setOffset(event)}
          />
          <span
            id="offsetValue"
            style={{
              display: "inline-block",
              minWidth: "3ch",
              textAlign: "right",
            }}
          >
            12
          </span>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Tooltip Position](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/tooltip-position/)

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['top', 'bottom', 'left', 'right'],
            offset: 12,
        },
    },
}
```

### Placement

The `placement` option positions the tooltip relative to its [anchor point](https://www.ag-grid.com/charts/archive/14.2.0/react/tooltips/#anchor-point), such as `top` or `top-right`. See the [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/react/tooltips/#reference-AgChartTooltipOptions-position-placement) for the full list of values.

Fallback positions can be provided in an array of `placement` values. The tooltip will use the first position that has sufficient space.

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['left', 'right'],
        },
    },
}
```

In the above example:

- Change the 'Placement' dropdown to 'Left + Right fallback'.
- Hover the leftmost datapoint and see that the tooltip goes to the right of the marker as there is no room on the left.

### Anchor Point

The options for `anchorTo` are:

- `node` - the active datapoint, such as the marker or bar.
- `pointer` - the mouse pointer or [single finger touch](https://www.ag-grid.com/charts/archive/14.2.0/react/touch/#single-finger-touch-dragging) position.
- `chart` - the chart container.

### Offset

Use `tooltip.position.offset` to control the gap between the tooltip and its anchor point in the placement direction, or `xOffset` and `yOffset` for specific horizontal and vertical offsets.

```js
{
    tooltip: {
        position: {
            anchorTo: 'node',
            placement: ['right', 'left'],
            offset: 20,
        },
    },
}
```

In the above example:

- Change the 'Placement' dropdown to 'Left + Right fallback' and change the 'Offset' value.
- Hover the leftmost datapoint and see that the offset is applied to the right of the marker, hover the rightmost datapoint and see that the offset is applied to the left.
- The directional `offset` can be used together with `xOffset` and `yOffset`.

## Tooltip Arrow

The default tooltip displays an arrow below it to indicate its exact point of origin. This is removed when the tooltip is constrained by the container or has an `xOffset` or `yOffset` supplied. The directional `offset` does not suppress the arrow.

#### Removing the Tooltip Arrow

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "value1",
        yName: "Sweaters Made",
      },
      {
        type: "bar",
        xKey: "month",
        stacked: true,
        yKey: "hats_made",
        yName: "Hats Made",
      },
    ],
    tooltip: {
      showArrow: true,
    },
  });

  const toggleTooltipArrow = () => {
    const nextOptions = clone(options);

    nextOptions.tooltip!.showArrow = !nextOptions.tooltip!.showArrow;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button onClick={toggleTooltipArrow}>Toggle Tooltip Arrow</button>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Removing the Tooltip Arrow](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/default-tooltip-arrow/)

Use the `tooltip.showArrow` option to change this behaviour.

```js
{
    tooltip: {
        showArrow: false,
    },
}
```

## Tooltip Pagination

Pagination allows cycling through overlapping datapoints by hovering and then clicking on the mouse. Use `pagination: true` to enable.

#### Tooltip Pagination

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  BubbleSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";

ModuleRegistry.registerModules([
  BubbleSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions<DataType>>({
    data: getData(),
    title: {
      text: "Most Populous Cities",
    },
    footnote: {
      text: "Source: Simple Maps",
    },
    series: [
      {
        type: "bubble",
        title: "Most populous cities",
        xKey: "lon",
        xName: "Longitude",
        yKey: "lat",
        yName: "Latitude",
        sizeKey: "population",
        sizeName: "Population",
        labelKey: "city",
        labelName: "City",
        maxSize: 50,
        tooltip: {
          renderer: ({ datum }) => ({ title: datum.city }),
        },
      },
    ],
    tooltip: {
      pagination: true,
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Tooltip Pagination](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/tooltip-pagination/)

Pagination will only become available when two or more data points are under the cursor.

```js
{
    tooltip: {
        pagination: true,
    },
}
```

In the above example:

- Hover overlapping bubbles.
- The cursor turns into a hand and the tooltip displays the number of data points under the cursor.
- Click in the current position to cycle through the data points, highlighting and displaying the tooltip for each in turn.

## Customisation

The exact contents and structure of a tooltip depends on the series and keys used.

Tooltips can contain any number of the following items, in order:-

- A heading - typically the x-value for a cartesian series.
- A series symbol - this graphically depicts a series and usually matches the legend item.
- A title - typically the identifying value for non-cartesian series.
- Some data rows - these contain one or more label and value pairs corresponding to information for a series.

### Using CSS Styles

#### Default Tooltip with Custom Styling

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import "./styles.css";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "month",
        yKey: "sweaters",
        yName: "Sweaters Made",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Default Tooltip with Custom Styling](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/default-tooltip-styling/)

The default tooltip uses the following CSS classes for the tooltip elements:

- `ag-charts-tooltip` for the entire tooltip container.
- `ag-charts-tooltip-heading` and `ag-charts-tooltip-title` for the tooltip headings and titles.
- `ag-charts-tooltip-symbol` for the series symbol.
- `ag-charts-tooltip-label` and `ag-charts-tooltip-value` for the elements in the data rows.

Adding custom CSS to these will change the styling of all the tooltips in your app.

```css
.ag-charts-tooltip {
    background-color: papayawhip;
    border: 2px solid peachpuff;
    color: maroon;
}

.ag-charts-tooltip-heading {
    font-weight: bold;
}
```

Note that your styles don't override the default tooltip styles but complement them.

### Modifying Content

The tooltip's content can be customised within the default template by using a `renderer` callback function.

#### Modifying Tooltip Content

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianSeriesTooltipRendererParams,
  AgChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";
import "./styles.css";

function renderer({
  datum,
  yKey,
  yName,
}: AgCartesianSeriesTooltipRendererParams<DataType>) {
  return {
    heading: "Clothing Production",
    title: yName?.toUpperCase(),
    data: [
      {
        label: datum.month,
        value: Number(datum[yKey]).toFixed(1),
      },
    ],
  };
}
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions<DataType>>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "month",
        tooltip: { renderer },
        yKey: "sweaters",
        yName: "Sweaters made",
        stacked: true,
      },
      {
        type: "bar",
        xKey: "month",
        tooltip: { renderer },
        yKey: "hats",
        yName: "Hats made",
        stacked: true,
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Modifying Tooltip Content](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/tooltip-content-title/)

```js
{
    tooltip: {
        renderer: function ({ datum, xKey, yKey, yName }) {
            return {
                heading: 'Clothing Production',
                title: yName.toUpperCase(),
                data: [
                    {
                        label: datum[xKey],
                        value: datum[yKey].toFixed(1),
                    },
                ],
            };
        },
    },
}
```

In this configuration:

- The `renderer` receives values associated with the highlighted data point. The actual type of the `params` object passed into the tooltip renderer will depend on the series type being used.
- The `renderer` returns an object with optional `heading`, `title`, `symbol`, and `data` fields.
- The `heading` and `title` must be plain text.
- The `data` field consists of an array of `label` and `value` fields, which are both plain text.
- Returning an empty string for any field will cause it to be omitted from the rendered tooltip.

### Modifying the Symbol

The tooltip symbol (the coloured marker that represents the series) can be customised using the `symbol` property in the renderer's return object.

Whether the symbol defaults to use a `marker`, `line`, or both depends on the series type and options used. Use the `enabled` option for each element to override this.

#### Customising the Tooltip Symbol

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AllCommunityModule,
  ModuleRegistry,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

let symbolEnabled = true;
ModuleRegistry.registerModules(AllCommunityModule);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    title: { text: "Monthly Temperatures" },
    series: [
      {
        type: "line",
        xKey: "month",
        yKey: "temperature",
        yName: "Temperature",
        tooltip: {
          renderer: () => {
            return {
              symbol: {
                marker: {
                  enabled: symbolEnabled,
                  shape: "star",
                  fill: "#cc0000",
                },
                line: {
                  enabled: symbolEnabled,
                  stroke: "#ff6b00",
                },
              },
            };
          },
        },
      },
    ],
  });

  const toggleSymbol = () => {
    symbolEnabled = !symbolEnabled;
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button onClick={toggleSymbol}>Toggle Symbol</button>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Customising the Tooltip Symbol](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/tooltip-symbol/)

```js
{
    tooltip: {
        renderer: function () {
            return {
                symbol: {
                    marker: {
                        enabled: true,
                        shape: 'star',
                        fill: '#cc0000',
                    },
                    line: {
                        enabled: true,
                        stroke: '#ff6b00',
                    },
                },
            };
        },
    },
}
```

In this example:

- Click the button to toggle the symbol. This will take effect on the next hover.
- The `marker` shape has been changed to `'star'` instead of inheriting the circle shape from the series.
- The marker and line colours have been changed from those used in the series.

### Using Custom Tooltips

To use a completely custom tooltip instead of modifying the contents of the default tooltip template, return an HTML string to the `renderer` including all the markup required.

#### Column Series with Tooltip Renderer

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgBarSeriesTooltipRendererParams,
  AgChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";
import "./styles.css";

function renderer(params: AgBarSeriesTooltipRendererParams<DataType>) {
  const { datum, fill, yKey } = params;
  return (
    '<div class="my-tooltip" style="--color:' +
    fill +
    '">' +
    datum.month +
    "&nbsp;&#10172;&nbsp;" +
    Number(datum[yKey]).toFixed(0) +
    "</div>"
  );
}
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions<DataType>>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "month",
        tooltip: { renderer },
        yKey: "sweaters",
        yName: "Sweaters made",
        stacked: true,
      },
      {
        type: "bar",
        xKey: "month",
        tooltip: { renderer },
        yKey: "hats",
        yName: "Hats made",
        stacked: true,
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Column Series with Tooltip Renderer](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/tooltip-renderer/)

```js
{
    series: [
        {
            type: 'bar',
            tooltip: {
                renderer: function (params) {
                    return (
                        '<div class="my-tooltip" style="--color:' +
                        params.fill +
                        '">' +
                        params.datum[params.xKey] +
                        '&nbsp;&#10172;&nbsp;' +
                        params.datum[params.yKey].toFixed(0) +
                        '</div>'
                    );
                },
            },
        },
    ],
}
```

In this configuration:

- The `renderer` receives values associated with the highlighted data point. The actual type of the `params` object passed into the tooltip renderer will depend on the series type being used.
- The `renderer` returns a single HTML string.
- The text gets its colour from the `fill` property in the `params` object. This matches the colour of the series.
- The label comes from `params.datum[params.xKey]` which is the name of the month.
- The value comes from the `params.datum[params.yKey]`, which we then stringify as an integer via `toFixed(0)`.
- We used a custom class names on the returned `div` element, so that we can apply custom styling.

## Tooltip Range

The `tooltip.range` property specifies how near the cursor must be to a node for the tooltip to appear. This can be defined on each series, as well as on the chart level.

#### Tooltip Range

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    tooltip: {
      range: "nearest",
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "month",
        yKey: "value1",
        yName: "Sweaters Made",
      },
      {
        type: "line",
        xKey: "month",
        yKey: "hats_made",
        yName: "Hats Made",
      },
    ],
  });

  const setInteractionRange = (event: Event) => {
    const nextOptions = clone(options);

    switch ((event.target as HTMLInputElement).value) {
      case "nearest":
        nextOptions.tooltip = { range: "nearest" };
        break;
      case "exact":
        nextOptions.tooltip = { range: "exact" };
        break;
      case "distance":
        nextOptions.tooltip = { range: 10 };
        break;
    }

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div
            className="button-group"
            role="group"
            aria-label="Interaction Range"
          >
            <input
              type="radio"
              id="interaction-range-nearest"
              name="interaction-range"
              defaultValue="nearest"
              defaultChecked
              onChange={(event) => setInteractionRange(event)}
            />
            <label htmlFor="interaction-range-nearest">Nearest</label>
            <input
              type="radio"
              id="interaction-range-exact"
              name="interaction-range"
              defaultValue="exact"
              onChange={(event) => setInteractionRange(event)}
            />
            <label htmlFor="interaction-range-exact">Exact</label>
            <input
              type="radio"
              id="interaction-range-distance"
              name="interaction-range"
              defaultValue="distance"
              onChange={(event) => setInteractionRange(event)}
            />
            <label htmlFor="interaction-range-distance">
              Distance (10 Pixels)
            </label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Tooltip Range](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/interaction-range/)

Options for `tooltip.range` are:

- `'nearest'` - Always shows the tooltip of the nearest node. This is the default for marker-based series such as `line` and `scatter`.
- `'exact'` - Only shows the tooltip when the user hovers over a node. This is the default for shape-based series such as `bar` and `pie`.
- An integer - Only shows the tooltip when the cursor is within the specified pixel distance of a node.

## Interaction with Tooltips

#### Tooltip Interaction

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgBarSeriesTooltipRendererParams,
  AgCartesianChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, getData } from "./data";
import "./styles.css";

function renderer(params: AgBarSeriesTooltipRendererParams<DataType>) {
  return `<div class="tooltip">
        <div class="tooltip-title">
            ${params.datum[params.xKey]}: ${params.datum[params.yKey]}
        </div>
        <div class="tooltip-body">
            <a tabindex="0" href="#" onclick="event.preventDefault(); console.log('Clicked within a tooltip')">Click here</a>
        </div>
    </div>`;
}
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions<DataType>>({
    data: getData(),
    series: [
      {
        type: "bar",
        xKey: "month",
        yKey: "sweaters",
        yName: "Sweaters Made",
        tooltip: {
          renderer,
          interaction: {
            enabled: true,
          },
        },
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Tooltip Interaction](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/tooltips/examples/tooltip-interaction/)

By default, you cannot hover over a tooltip or select its text.

Set the `series[].tooltip.interaction.enabled` flag to `true` to enable selecting the text and clicking links within the tooltip.

## API Reference

#### Chart Tooltip Options

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Set to `false` to disable tooltips for all series in the chart. |
| mode | 'single' \| 'shared' \| 'compact' |  | Group multiple series into the same tooltip |
| showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. This will be used unless overridden by the series `tooltip.range` option. |
| position | AgTooltipPositionOptions |  | The position of the tooltip. This will be used unless overridden by the series `tooltip.range` option. |
| position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| pagination | boolean |  | The configuration for tooltip pagination. |
| delay | DurationMs |  | The time interval (in milliseconds) after which the tooltip is shown. |
| wrapping | 'never' \| 'always' \| 'hyphenate' \| 'on-space' | 'hyphenate' | Text wrapping strategy for tooltips. - `'always'` will always wrap text to fit within the tooltip. - `'hyphenate'` is similar to `'always'`, but inserts a hyphen (`-`) if forced to wrap in the middle of a word. - `'on-space'` will only wrap on white space. If there is no possibility to wrap a line on space and satisfy the tooltip dimensions, the text will be truncated. - `'never'` disables text wrapping. |

#### Series Tooltip Options

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| enabled | boolean |  | Whether to show tooltips when the series are hovered over. |
| showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. Each series type uses its own default; typically this is `'nearest'` for marker-based series and `'exact'` for shape-based series. |
| position | AgTooltipPositionOptions |  | The position of the tooltip. Each series type uses its own default; typically this is `'node'` for marker-based series and `'pointer'` for shape-based series. |
| position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| interaction | AgSeriesTooltipInteraction |  | Configuration for tooltip interaction. |
| interaction.enabled (required) | boolean |  | Set to `true` to keep the tooltip open when the mouse is hovering over it, and enable clicking tooltip text |
| renderer | Renderer |  | Function used to create the content for tooltips. |
